//----------------------------------------------------------------------
//
// t@C : pwrtest.v
// @\       : FPGA׃eXgHŏʃW[ Verilog
// XV   : 2006/11/16 - ver 1.0  
//
// Copyright(C)2006 K.Ochiai. All rights reserved.
//
//----------------------------------------------------------------------
module pwrtest(CLK,RSTN,STOPN,TRATE,LOADN,LDATA,LEDN);
	// o͐M`
	input			CLK;		// 30MHzNbN
	input			RSTN;		// 񓯊ZbgEXCb`(_FSW1)
	input			STOPN;		// ~XCb`(_FSW2)
	input [7:0]		TRATE;		// gO񐔐ݒXCb`(_FDSW1-8)
	input			LOADN;		// [hM(_F_~[FEB[NEvAbvŏԌŒ)
	input [3:0]		LDATA;		// [hEf[^(_F_~[FEB[NEvAbvŏԌŒ)
	output			LEDN;		// CWP[^LED(_FD1)

	// 萔`
	parameter		depth = 2048;	// pCvC[

	// M`
	wire			ck210m;		// 210MHzNbN
	wire			pllrst;		// PLLZbg
	wire			modrst;		// W[EZbg
	wire			locked;		// PLLbN
	wire			cke;		// NbNECl[u

	wire			load_ap;	// [hMGbWoM

	wire			tdetect;	// gOoM
	wire			iled;		// LEDM

	wire			pattern;	// p^[M
	wire			ind_cke;	// CWP[^EW[̃NbNECl[uM

	// WX^`
	reg				loadn_ps;	// O͂̃VNiCU
	reg				loadn_s;	//   NbN̂2iŎ󂯂
	reg [3:0]		ldata_ps;
	reg [3:0]		ldata_s;
	reg [7:0]		trate_ps;
	reg [7:0]		trate_s;
	reg				stopn_ps;
	reg				stopn_s;
	reg				loadn_sft;	// [hMVtg

	// ZbgM_]
	assign pllrst = ~RSTN;

	// PLLW[ڑ
	clkgen inst_clkgen(
		.areset(pllrst),
		.inclk0(CLK),
		.c0(ck210m),
		.locked(locked)
	);

	// PLLAbNW[EZbgƂ
	assign modrst = ~locked;

	// ~XCb`̃VNiCU
	always @(posedge ck210m or posedge modrst) begin
		if(modrst) begin
			stopn_ps <= 1'b1;
			stopn_s  <= 1'b1;
		end else begin
			stopn_ps <= STOPN;
			stopn_s  <= stopn_ps;
		end
	end

	// VNiCUo͂NbNECl[uƂ
	assign cke = stopn_s;

	// ̑͂̃VNiCU
	always @(posedge ck210m or posedge modrst) begin
		if(modrst) begin
			loadn_ps	<= 1'b1;
			loadn_s		<= 1'b1;
			loadn_sft	<= 1'b1;
			ldata_ps	<= 4'b1111;
			ldata_s		<= 4'b1111;
			trate_ps	<= 8'b11111111;
			trate_s		<= 8'b11111111;
		end else if(cke) begin
			loadn_ps	<= LOADN;
			loadn_s		<= loadn_ps;
			loadn_sft	<= loadn_s;
			ldata_ps	<= LDATA;
			ldata_s		<= ldata_ps;
			trate_ps	<= TRATE;
			trate_s		<= trate_ps;
		end
	end

	// [hM̗GbWo
	assign load_ap = ((loadn_s == 1'b0) && (loadn_sft == 1'b1)) ? 1'b1 : 1'b0;

	// p^[W[ڑ
	patterngen inst_patterngen(
		.CLK(ck210m),
		.CKE(cke),
		.RST(modrst),
		.TRATE(trate_s),
		.POUT(pattern)
	);

	// ׃W[ڑ
	loadmod #(depth) inst_loadmod(
		.CLK(ck210m),
		.CKE(cke),
		.RST(modrst),
		.LOAD(load_ap),
		.LDATA(ldata_s),
		.PIN(pattern),
		.TDETECT(tdetect)
	);

	// CWP[^EW[̃NbNECl[uM
    //   NbNECl[uŁC׃W[̃gOoƂ
	assign ind_cke = tdetect & cke;

	// CWP[^EW[ڑ
	indicator inst_indicator(
		.CLK(ck210m),
		.CKE(ind_cke),
		.RST(modrst),
		.LED(iled)
	);

	// LED_ŐM_]
	assign LEDN = ~iled;

endmodule