------------------------------------------------------------------------
--
-- t@C : pwrtest.vhd
-- @\       : FPGA׃eXgHŏʃW[
-- XV   : 2006/11/11 - ver 1.0  
--
-- Copyright(C)2006 K.Ochiai. All rights reserved.
--
------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

-------------------------
-- GeBeB
-------------------------
entity pwrtest is
port(
		CLK		: in std_logic;						-- 30MHzNbN
		RSTN	: in std_logic;						-- 񓯊ZbgEXCb`(_FSW1)
		STOPN	: in std_logic;						-- ~XCb`(_FSW2)
		TRATE	: in std_logic_vector(7 downto 0);	-- gO񐔐ݒXCb`(_FDSW1-8)
		LOADN	: in std_logic;						-- [hM(_F_~[FEB[NEvAbvŏԌŒ)
		LDATA	: in std_logic_vector(3 downto 0);	-- [hEf[^(_F_~[FEB[NEvAbvŏԌŒ)
		LEDN	: out std_logic						-- CWP[^LED(_FD1)
);
end pwrtest;

-------------------------
-- A[LeN`
-------------------------
architecture rtl of pwrtest is
-- 萔`
constant depth		: integer := 2048;				-- pCvC[

-- WX^/M`
signal ck210m		: std_logic;					-- 210MHzNbN
signal pllrst		: std_logic;					-- PLLZbg
signal modrst		: std_logic;					-- W[EZbg
signal locked		: std_logic;					-- PLLbN
signal cke			: std_logic;					-- NbNECl[u

signal loadn_ps		: std_logic;					-- O͂̃VNiCU
signal loadn_s		: std_logic;					--   NbN̂2iŎ󂯂
signal ldata_ps		: std_logic_vector(3 downto 0);
signal ldata_s		: std_logic_vector(3 downto 0);
signal trate_ps		: std_logic_vector(7 downto 0);
signal trate_s		: std_logic_vector(7 downto 0);
signal stopn_ps		: std_logic;
signal stopn_s		: std_logic;

signal loadn_sft	: std_logic;					-- [hMVtg
signal load_ap		: std_logic;					-- [hMGbWoM

signal tdetect		: std_logic;					-- gOoM
signal iled			: std_logic;					-- LEDM

signal pattern		: std_logic;					-- p^[M
signal ind_cke		: std_logic;					-- CWP[^EW[̃NbNECl[uM

-- PLLW[ER|[lg`
component clkgen
port(
		areset	: in std_logic  := '0';				-- 񓯊Zbg
		inclk0	: in std_logic  := '0';				-- NbN(30MHz)
		c0		: out std_logic;					-- NbNo(210MHz(7x))
		locked	: out std_logic 					-- PLLbN
	);
end component;

-- ׃W[ER|[lg`
component loadmod
generic(
		DEPTH	: integer := 2048					-- pCvC[(ftHg2048i)
); 
port(
		CLK		: in std_logic;						-- NbN
		CKE		: in std_logic;						-- NbNECl[u
		RST		: in std_logic;						-- 񓯊Zbg
		LOAD	: in std_logic;						-- [hM
		LDATA	: in std_logic_vector(3 downto 0);	-- [hEf[^
		PIN		: in std_logic;						-- ĩp^[
		TDETECT	: out std_logic						-- gOo
);
end component;

-- CWP[^EW[ER|[lg`
component indicator
port(
		CLK		: in std_logic;						-- NbN
		CKE		: in std_logic;						-- NbNECl[u
		RST		: in std_logic;						-- 񓯊Zbg
		LED		: out std_logic						-- LED_ŐM
);
end component;

-- p^[W[ER|[lg`
component patterngen
port(
		CLK		: in std_logic;						-- NbN
		CKE		: in std_logic;						-- NbNECl[u
		RST		: in std_logic;						-- 񓯊Zbg
		TRATE	: in std_logic_vector(7 downto 0);	-- gO
		POUT	: out std_logic						-- p^[o
);
end component;

-- A[LeN`{
begin
	pllrst <= not RSTN;								-- ZbgM_]

	-- PLLW[ڑ
	inst_clkgen:clkgen
	port map(	areset => pllrst,
				inclk0 => CLK,
				c0     => ck210m,
				locked => locked
	);

	modrst <= not locked;							-- PLLAbNW[EZbgƂ

	-- ~XCb`̃VNiCU
	process(ck210m,modrst)
	variable i : integer;
	begin
		if(modrst = '1') then						-- Zbg
			stopn_ps	<= '1';
			stopn_s		<= '1';
		elsif(ck210m'event and ck210m = '1') then	-- NbNオ蓯
			stopn_ps	<= STOPN;
			stopn_s		<= stopn_ps;
		end if;
	end process;

	cke <= stopn_s;									-- VNiCUo͂NbNECl[uƂ

	-- ̑͂̃VNiCU
	process(ck210m,modrst)
	variable i : integer;
	begin
		if(modrst = '1') then						-- Zbg
			loadn_ps	<= '1';
			loadn_s		<= '1';
			loadn_sft	<= '1';
			ldata_ps	<= (others => '1');
			ldata_s		<= (others => '1');
			trate_ps	<= (others => '1');
			trate_s		<= (others => '1');
		elsif(ck210m'event and ck210m = '1') then	-- NbNオ蓯
			if(cke = '1') then						-- @NbNECl[u'1'̂Ƃȉ̉H삷
				loadn_ps	<= LOADN;
				loadn_s		<= loadn_ps;
				loadn_sft	<= loadn_s;				-- GbWô߂Vtg
				ldata_ps	<= LDATA;
				ldata_s		<= ldata_ps;
				trate_ps	<= TRATE;
				trate_s		<= trate_ps;
			end if;
		end if;
	end process;

	-- [hM̗GbWo
	load_ap <= '1' when loadn_s = '0' and loadn_sft = '1' else '0';

	-- p^[W[ڑ
	inst_patterngen:patterngen
	port map(	CLK		=> ck210m,
				CKE		=> cke,
				RST		=> modrst,
				TRATE	=> trate_s,
				POUT	=> pattern
	);

	-- ׃W[ڑ
	inst_loadmod:loadmod
	generic map(
				DEPTH	=> depth
	)
	port map(	CLK		=> ck210m,
				CKE		=> cke,
				RST		=> modrst,
				LOAD	=> load_ap,
				LDATA	=> ldata_s,
				PIN		=> pattern,
				TDETECT => tdetect
	);

	-- CWP[^EW[̃NbNECl[uM
    --   NbNECl[uŁC׃W[̃gOoƂ
	ind_cke <= tdetect and cke;

	-- CWP[^EW[ڑ
	inst_indicator:indicator
	port map(	CLK		=> ck210m,
				CKE		=> ind_cke,
				RST		=> modrst,
				LED		=> iled
	);

	LEDN <= not iled;								-- LED_ŐM_]

end rtl;
